love.filesystem.setIdentity("zombiebaseball")

function love.load()
  poly = {}
  poly[1] = {}
  poly[1].abs_coords = {300, 300, 0, 300, -300, 0, -300, -300, 0, -300, 300, 0}
  poly[1].colour = {0, 140, 0}
  for i = 1, 150, 1 do
    poly[1+i] = {}
    poly[1+i].abs_coords = {300, -300 + i * 4 + 1, 0, 300, -300 + i * 4 + 3, 0, -300, -300 + i * 4 + 3, 0, -300, -300 + i * 4 + 1, 0}
    poly[1+i].colour = {0, 150, 0}
  end
  poly[152] = {}
  poly[152].abs_coords = {-1, 0, 0, 39, -40, 0, 39, -38, 0, 1, 0, 0}
  poly[152].colour = {219, 156, 97}
  poly[153] = {}
  poly[153].abs_coords = {-1, 0, 0, 39, 40, 0, 39, 38, 0, 1, 0, 0}
  poly[153].colour = poly[152].colour
  poly[154] = {}
  poly[154].abs_coords = {39, -40, 0, 53, -30, 0, 62, -20, 0, 66, -10, 0, 67, 0, 0, 51, 0, 0, 26, -25, 0}
  poly[154].colour = poly[152].colour
  poly[155] = {}
  poly[155].abs_coords = {39, 40, 0, 53, 30, 0, 62, 20, 0, 66, 10, 0, 67, 0, 0, 51, 0, 0, 26, 25, 0}
  poly[155].colour = poly[152].colour
  poly[156] = {}
  poly[156].abs_coords = {-6, 0, 0, -4.3, -4.3, 0, 0, -6, 0, 4.3, -4.3, 0, 6, 0, 0, 4.3, 4.3, 0, 0, 6, 0, -4.3, 4.3, 0}
  poly[156].colour = poly[152].colour
  poly[157] = {}
  poly[157].abs_coords = {22, 0, 0, 23, -2, 0, 25, -3, 0, 27, -2, 0, 28, 0, 0, 27, 2, 0, 25, 3, 0, 23, 2, 0}
  poly[157].colour = poly[152].colour
  
  inview = {}
  dist = {}
  
  position = {-10, 0, 0}
  velocity = {0, 0, 0}
  viewpoint = {}
  viewdir = {0, 0}
  viewdir2 = {0, 0}
  viewdir_cart = {}
  height = 1.8
  width = 0.3
  recoil_v = 0
  recoil_p = 0
  recoil_f = 0
  
  zombie_graphic = {}
  zombie_graphic[1] = {}
  zombie_graphic[1].image = love.graphics.newImage("gfx/zombie_fielder.png")
  zombie_graphic[1].top = 18
  zombie_graphic[1].bottom = 1005
  zombie_graphic[1].left = 61
  zombie_graphic[1].right = 431
  zombie = {}
  zombie[1] = make_zombie({25,   0, 0})
  zombie[2] = make_zombie({-4,   0, 0})
  zombie[3] = make_zombie({26,  26, 0})
  zombie[4] = make_zombie({51,  15, 0})
  zombie[5] = make_zombie({26, -26, 0})
  zombie[6] = make_zombie({51, -15, 0})
  zombie[7] = make_zombie({80, -50, 0})
  zombie[8] = make_zombie({90,   0, 0})
  zombie[9] = make_zombie({80,  50, 0})
  
  i = 0
  jump = false
  weapon = 1
  
  bat = love.graphics.newImage("gfx/bat.png")
  gun1 = love.graphics.newImage("gfx/gun1.png")
  muzzle_flash1 = love.graphics.newImage("gfx/muzzle_flash1.png")
  muzzle_flash2 = love.graphics.newImage("gfx/muzzle_flash2.png")
  
  gun_sound1 = love.sound.newSoundData("sfx/shotgun.wav")
  swing_sound1 = love.sound.newSoundData("sfx/swing1.wav")
  
  draw_threshold = 0.2
  zombie_draw_threshold = 0.5
  zoom = 0.8
  scale = zoom * math.max(love.graphics.getWidth(), love.graphics.getHeight())
  
  love.graphics.setLine(2, 'smooth')
  framerate = 0
  draw_muzzle_flash = 0
  muzzle_flash_angle = 0
  swing = false
  
  love.mouse.setGrab(true)
  love.mouse.setPosition(love.graphics.getWidth()/2, love.graphics.getHeight()/2)
  love.mouse.setVisible(false)
  m_diff_x_filt = 0
  m_diff_y_filt = 0
end








function love.update(dt)
  if draw_muzzle_flash > 0 then
    draw_muzzle_flash = draw_muzzle_flash - dt
  end
  recoil_p = math.min(math.pi/2, recoil_p + recoil_v * dt)
  if recoil_p < 0 then
    recoil_p = 0
    recoil_v = 0
  end
  recoil_v = recoil_v - 100 * dt
  recoil_f = 0.9 * recoil_f + 0.1 * recoil_p
  
  m_diff_x = love.mouse.getX() - love.graphics.getWidth()/2
  m_diff_y = love.mouse.getY() - love.graphics.getHeight()/2
  if swing then
    m_diff_x_filt = m_diff_x_filt - 500 * dt
    if m_diff_x_filt < -45 then
      m_diff_x_filt = -45
      swing = false
    end
  else
    m_diff_x_filt = math.min(35, math.max(-45, 0.95 * m_diff_x_filt + 0.05 * m_diff_x))
  end
  m_diff_y_filt = math.min(25, math.max(-25, 0.95 * m_diff_y_filt + 0.05 * m_diff_y))
  love.mouse.setPosition(love.graphics.getWidth()/2, love.graphics.getHeight()/2)
  framerate = 1/dt
  viewdir[1] = viewdir[1] + m_diff_x / 1000
  viewdir[2] = math.max(-math.pi/2, math.min(math.pi/2, viewdir[2] - m_diff_y / 1000))
  viewdir_cart[1] = math.cos(viewdir[1])
  viewdir_cart[2] = math.sin(viewdir[1])
  
  if jump then
    position[1] = position[1] + dt * velocity[1]
    position[2] = position[2] + dt * velocity[2]
    position[3] = position[3] + dt * velocity[3]
    velocity[3] = velocity[3] - dt * 9.8
    if position[3] <= 0 then
      position[3] = 0
      velocity[3] = 0
      jump = false
    end
  else
    velocity[1] = 0
    velocity[2] = 0
    if love.keyboard.isDown("w") then
      velocity[1] = velocity[1] + 6 * viewdir_cart[1]
      velocity[2] = velocity[2] + 6 * viewdir_cart[2]
    end
    if love.keyboard.isDown("s") then
      velocity[1] = velocity[1] - 6 * viewdir_cart[1]
      velocity[2] = velocity[2] - 6 * viewdir_cart[2]
    end
    if love.keyboard.isDown("a") then
      velocity[1] = velocity[1] + 6 * viewdir_cart[2]
      velocity[2] = velocity[2] - 6 * viewdir_cart[1]
    end
    if love.keyboard.isDown("d") then
      velocity[1] = velocity[1] - 6 * viewdir_cart[2]
      velocity[2] = velocity[2] + 6 * viewdir_cart[1]
    end
    position[1] = position[1] + dt * velocity[1]
    position[2] = position[2] + dt * velocity[2]
  end
  viewdir2[1] = viewdir[1]
  viewdir2[2] = viewdir[2] + recoil_f
  
  -- Collision detection
  push = {0, 0, 0}
  speed = math.sqrt(velocity[1]^2 + velocity[2]^2)
  for i = 1, #zombie, 1 do
    zombie[i].push = {0, 0, 0}
    zombie[i].speed = math.sqrt(zombie[i].velocity[1]^2 + zombie[i].velocity[2]^2)
    overlap = zombie[i].width + width - math.sqrt((zombie[i].position[1] - position[1])^2 + (zombie[i].position[2] - position[2])^2)
    if overlap > 0 and zombie[i].speed + speed > 0 then
      push_angle = math.atan2(zombie[i].position[2] - position[2], zombie[i].position[1] - position[1])
      f_speed = zombie[i].speed / (zombie[i].speed + speed)
      zombie[i].push[1] = zombie[i].push[1] + f_speed * math.cos(push_angle) * overlap
      zombie[i].push[2] = zombie[i].push[2] + f_speed * math.sin(push_angle) * overlap
      push[1] = push[1] - (1 - f_speed) * math.cos(push_angle) * overlap
      push[2] = push[2] - (1 - f_speed) * math.sin(push_angle) * overlap
    end
    for j = i + 1, #zombie, 1 do
      zombie[j].speed = math.sqrt(zombie[j].velocity[1]^2 + zombie[j].velocity[2]^2)
      overlap = zombie[i].width + zombie[j].width - math.sqrt((zombie[i].position[1] - zombie[j].position[1])^2 + (zombie[i].position[2] - zombie[j].position[2])^2)
      if overlap > 0 and zombie[i].speed + zombie[j].speed > 0 then
        push_angle = math.atan2(zombie[i].position[2] - zombie[j].position[2], zombie[i].position[1] - zombie[j].position[1])
        f_speed = zombie[i].speed / (zombie[i].speed + zombie[j].speed)
        zombie[i].push[1] = zombie[i].push[1] + f_speed * math.cos(push_angle) * overlap
        zombie[i].push[2] = zombie[i].push[2] + f_speed * math.sin(push_angle) * overlap
        zombie[j].push[1] = zombie[j].push[1] - (1 - f_speed) * math.cos(push_angle) * overlap
        zombie[j].push[2] = zombie[j].push[2] - (1 - f_speed) * math.sin(push_angle) * overlap
      end
    end
  end
  position[1] = position[1] + push[1]
  position[2] = position[2] + push[2]
  position[3] = position[3] + push[3]
  for i = 1, #zombie, 1 do
    zombie[i].position[1] = zombie[i].position[1] + zombie[i].push[1]
    zombie[i].position[2] = zombie[i].position[2] + zombie[i].push[2]
    zombie[i].position[3] = zombie[i].position[3] + zombie[i].push[3]
  end
  
  viewpoint[1] = position[1]
  viewpoint[2] = position[2]
  viewpoint[3] = position[3] + height
  
  perspective_poly = {}
  dist = {}
  
  for i = 1, #poly, 1 do
    poly[i].rel_coords, poly[i].drawable = get_relative_coords(poly[i].abs_coords, viewpoint)
    if poly[i].drawable then
      apply_poly_perspective(poly[i])
    end
  end
  
  for i = 1, #zombie, 1 do
    -- Calculate zombie distance for sorting
    zombie[i].dist = math.sqrt((position[1] - zombie[i].position[1])^2 + (position[2] - zombie[i].position[2])^2)
    
    zombie[i].drawable = true
    get_zombie_h_coords(zombie[i])
    zombie[i].rel_h_coords, zombie[i].drawable = get_relative_coords(zombie[i].abs_h_coords, viewpoint)
    clip_zombie_h_coordinates(zombie[i])
    get_zombie_w_coords(zombie[i])
    zombie[i].rel_w_coords = get_relative_coords(zombie[i].abs_w_coords, viewpoint)
    zombie[i].clip_w_coords = zombie[i].rel_w_coords
    apply_zombie_perspective(zombie[i])
  end
  
  --table.sort(poly, function (a, b) return a.dist > b.dist end)
  table.sort(zombie, function (a, b) return a.dist > b.dist end)
end












function love.draw(dt)
  love.graphics.setColor(130, 160, 255)
  love.graphics.polygon('fill', 0, 0, 0, love.graphics.getHeight(), love.graphics.getWidth(), love.graphics.getHeight(), love.graphics.getWidth(), 0)
  for i = 1, #poly, 1 do
    if poly[i].drawable then
      love.graphics.setColor(poly[i].colour[1], poly[i].colour[2], poly[i].colour[3])
      love.graphics.polygon('fill', poly[i].pers_coords)
    end
  end
  love.graphics.setColor(255, 255, 255)
  
  for i = 1, #zombie, 1 do
    if zombie[i].drawable then
      love.graphics.draw(zombie_graphic[zombie[i].style].image,
        zombie[i].pers_h_coords[1], zombie[i].pers_h_coords[2],
        math.atan2(zombie[i].pers_h_coords[2] - zombie[i].pers_h_coords[4], zombie[i].pers_h_coords[1] - zombie[i].pers_h_coords[3]) - math.pi / 2,
        math.sqrt((zombie[i].pers_w_coords[3] - zombie[i].pers_w_coords[1])^2 + (zombie[i].pers_w_coords[4] - zombie[i].pers_w_coords[2])^2) / (zombie_graphic[zombie[i].style].right - zombie_graphic[zombie[i].style].left),
        math.sqrt((zombie[i].pers_h_coords[2] - zombie[i].pers_h_coords[4])^2 + (zombie[i].pers_h_coords[1] - zombie[i].pers_h_coords[3])^2) / (zombie_graphic[zombie[i].style].bottom - zombie_graphic[zombie[i].style].top) / (zombie[i].f_top - zombie[i].f_bottom),
        (zombie_graphic[zombie[i].style].right + zombie_graphic[zombie[i].style].left) / 2,
        zombie_graphic[zombie[i].style].bottom - zombie[i].f_bottom * (zombie_graphic[zombie[i].style].bottom - zombie_graphic[zombie[i].style].top))
      --love.graphics.setColor(127, 127, 127)
      --love.graphics.polygon('fill', zombie[i].pers_coords)
    end
  end
  
  if weapon == 1 then
    love.graphics.draw(bat, love.graphics.getWidth()/2 + 100, love.graphics.getHeight() + 250 + 10 * m_diff_y_filt,
      -0.4 * math.pi + m_diff_x_filt/50, 0.5, 0.5, 328, 245)
  elseif weapon == 2 then
    if draw_muzzle_flash > 0 then
      love.graphics.draw(muzzle_flash2, 0.85 * love.graphics.getWidth() - 275, love.graphics.getHeight() - 275, muzzle_flash_angle, 0.6, 0.6, 127, 127)
    end
    love.graphics.draw(gun1, 0.85 * love.graphics.getWidth(), love.graphics.getHeight() + 10, 0, 0.6, 0.6, 678, 1023)
    love.graphics.line(love.graphics.getWidth()/2 - 20, love.graphics.getHeight()/2, love.graphics.getWidth()/2 + 20, love.graphics.getHeight()/2)
    love.graphics.line(love.graphics.getWidth()/2, love.graphics.getHeight()/2 - 20, love.graphics.getWidth()/2, love.graphics.getHeight()/2 + 20)
  end
  
  --love.graphics.setColor(0, 0, 0)
  --love.graphics.print("Weapon: " .. weapon, 40, 40)
end

function love.keypressed(button, u)
  if button == " " and not jump then
    jump = true
    velocity[3] = 5
  elseif button == "escape" then
    love.event.push("q")
  end
end

function love.keyreleased(button, u)

end

function love.mousepressed(x, y, button)
  if button == "l" then		-- Shoot
    if weapon == 1 then
      if m_diff_x_filt > -5 then
        swing = true
        love.audio.newSource(swing_sound1):play()
      end
    elseif weapon == 2 then
      draw_muzzle_flash = 0.05
      muzzle_flash_angle = 2 * math.pi * math.random()
      love.audio.newSource(gun_sound1):play()
      recoil_v = 5
      recoil_p = 0
      recoil_f = 0
      viewdir[1] = viewdir2[1]
      viewdir[2] = viewdir2[2]
    end
  elseif button == "wu" then	-- Scroll wheel up
    weapon = weapon + 1
    if weapon > 2 then weapon = 1 end
  elseif button == "wd" then	-- Scroll wheel down
    weapon = weapon - 1
    if weapon < 1 then weapon = 2 end
  end
end

















function make_zombie(this_position)
  if type(this_position) ~= "table" or #this_position ~= 3 or type(this_position[1]) ~= "number" or type(this_position[2]) ~= "number" or type(this_position[3]) ~= "number" then return nil end
  this_zombie = {}
  this_zombie.position = this_position
  this_zombie.style = 1
  this_zombie.height = 1.9
  this_zombie.width = this_zombie.height * (zombie_graphic[this_zombie.style].right - zombie_graphic[this_zombie.style].left) / (zombie_graphic[this_zombie.style].bottom - zombie_graphic[this_zombie.style].top)
  this_zombie.velocity = {0, 0, 0}
  return this_zombie
end

function get_zombie_h_coords(this_zombie)
  if not this_zombie.drawable then return end
  this_zombie.abs_h_coords = {}
  this_zombie.abs_h_coords[1] = this_zombie.position[1]
  this_zombie.abs_h_coords[2] = this_zombie.position[2]
  this_zombie.abs_h_coords[3] = this_zombie.position[3]
  this_zombie.abs_h_coords[4] = this_zombie.position[1]
  this_zombie.abs_h_coords[5] = this_zombie.position[2]
  this_zombie.abs_h_coords[6] = this_zombie.position[3] + this_zombie.height
end

function get_zombie_w_coords(this_zombie)
  if not this_zombie.drawable then return end
  this_zombie.abs_w_coords = {}
  local xvec = math.sin(viewdir2[1])
  local yvec = -math.cos(viewdir2[1])
  this_zombie.abs_w_coords[1] = this_zombie.position[1] + xvec * this_zombie.width / 2
  this_zombie.abs_w_coords[2] = this_zombie.position[2] + yvec * this_zombie.width / 2
  this_zombie.abs_w_coords[3] = this_zombie.position[3] + this_zombie.height * (this_zombie.f_top + this_zombie.f_bottom) / 2
  this_zombie.abs_w_coords[4] = this_zombie.position[1] - xvec * this_zombie.width / 2
  this_zombie.abs_w_coords[5] = this_zombie.position[2] - yvec * this_zombie.width / 2
  this_zombie.abs_w_coords[6] = this_zombie.position[3] + this_zombie.height * (this_zombie.f_top + this_zombie.f_bottom) / 2
end

function get_relative_coords(abs_coords, this_viewpoint)
  if abs_coords == nil then return nil, false end
  local vertices = #abs_coords / 3
  local rel_coords = {}
  local drawable = false
  
  -- Get coordinates relative to viewpoint
  for j = 0, vertices - 1, 1 do
    rel_coords[3*j+1] = abs_coords[3*j+1] - this_viewpoint[1]
    rel_coords[3*j+2] = abs_coords[3*j+2] - this_viewpoint[2]
    rel_coords[3*j+3] = abs_coords[3*j+3] - this_viewpoint[3]
  end
  
  for j = 0, vertices - 1, 1 do
    -- Rotate coordinates relative to view direction
    omega = math.atan2(rel_coords[3*j+2], rel_coords[3*j+1]) - viewdir2[1]
    d = math.sqrt(rel_coords[3*j+1]^2 + rel_coords[3*j+2]^2)
    rel_coords[3*j+1] = d * math.cos(omega)
    rel_coords[3*j+2] = d * math.sin(omega)
    omega = math.atan2(rel_coords[3*j+3], rel_coords[3*j+1]) - viewdir2[2]
    d = math.sqrt(rel_coords[3*j+1]^2 + rel_coords[3*j+3]^2)
    rel_coords[3*j+1] = d * math.cos(omega)
    rel_coords[3*j+3] = d * math.sin(omega)
    
    -- Check if polygon drawable
    if rel_coords[3*j+1] > draw_threshold then
      drawable = true
    end
  end
  
  return rel_coords, drawable
end

function apply_poly_perspective(this_poly)
  local vertices = #this_poly.rel_coords / 3
  
  -- Calculate polygon distance for sorting
  max_dist = this_poly.rel_coords[1]
  min_dist = this_poly.rel_coords[1]
  for j = 0, vertices - 1, 1 do
    if this_poly.rel_coords[3*j+1] > max_dist then max_dist = this_poly.rel_coords[3*j+1] end
    if this_poly.rel_coords[3*j+1] < min_dist then min_dist = this_poly.rel_coords[3*j+1] end
  end
  this_poly.dist = (max_dist + min_dist) / 2
  
  -- Clip polygon at drawing threshold
  this_poly.clip_coords = clip_poly_coordinates(this_poly.rel_coords, draw_threshold)
  
  -- Add perspective
  this_poly.pers_coords = {}
  for j = 0, k - 1, 1 do
    this_poly.pers_coords[2*j+1] = love.graphics.getWidth()  / 2 + scale * this_poly.clip_coords[3*j+2] / this_poly.clip_coords[3*j+1]
    this_poly.pers_coords[2*j+2] = love.graphics.getHeight() / 2 - scale * this_poly.clip_coords[3*j+3] / this_poly.clip_coords[3*j+1]
  end
end

function apply_zombie_perspective(this_zombie)
  if not this_zombie.drawable then return end
  -- Add perspective
  this_zombie.pers_h_coords = {}
  this_zombie.pers_h_coords[1] = love.graphics.getWidth()  / 2 + scale * this_zombie.clip_h_coords[2] / this_zombie.clip_h_coords[1]
  this_zombie.pers_h_coords[2] = love.graphics.getHeight() / 2 - scale * this_zombie.clip_h_coords[3] / this_zombie.clip_h_coords[1]
  this_zombie.pers_h_coords[3] = love.graphics.getWidth()  / 2 + scale * this_zombie.clip_h_coords[5] / this_zombie.clip_h_coords[4]
  this_zombie.pers_h_coords[4] = love.graphics.getHeight() / 2 - scale * this_zombie.clip_h_coords[6] / this_zombie.clip_h_coords[4]
  this_zombie.pers_w_coords = {}
  this_zombie.pers_w_coords[1] = love.graphics.getWidth()  / 2 + scale * this_zombie.clip_w_coords[2] / this_zombie.clip_w_coords[1]
  this_zombie.pers_w_coords[2] = love.graphics.getHeight() / 2 - scale * this_zombie.clip_w_coords[3] / this_zombie.clip_w_coords[1]
  this_zombie.pers_w_coords[3] = love.graphics.getWidth()  / 2 + scale * this_zombie.clip_w_coords[5] / this_zombie.clip_w_coords[4]
  this_zombie.pers_w_coords[4] = love.graphics.getHeight() / 2 - scale * this_zombie.clip_w_coords[6] / this_zombie.clip_w_coords[4]
end

function clip_zombie_h_coordinates(this_zombie, clip_threshold)
  if not this_zombie.drawable then return end
  local n = love.graphics.getHeight() / (2 * scale)
  if this_zombie.rel_h_coords[4] == this_zombie.rel_h_coords[1] then
    if this_zombie.rel_h_coords[1] < draw_threshold then
      this_zombie.drawable = false
      return
    end
    
    -- Clip bottom if necessary
    if (scale * this_zombie.rel_h_coords[3] / this_zombie.rel_h_coords[1] > -love.graphics.getHeight() / 2) then
      this_zombie.f_bottom = 0
    else
      z = -n * this_zombie.rel_h_coords[1]
      this_zombie.f_bottom = (z - this_zombie.rel_h_coords[3]) / (this_zombie.rel_h_coords[6] - this_zombie.rel_h_coords[4])
    end
    
    -- Clip top if necessary
    if (scale * this_zombie.rel_h_coords[6] / this_zombie.rel_h_coords[4] < love.graphics.getHeight() / 2) then
      this_zombie.f_top = 1
    else
      x = n * this_zombie.rel_h_coords[1]
      this_zombie.f_top = (z - this_zombie.rel_h_coords[3]) / (this_zombie.rel_h_coords[6] - this_zombie.rel_h_coords[4])
    end
  else
    local m = (this_zombie.rel_h_coords[6] - this_zombie.rel_h_coords[3]) / (this_zombie.rel_h_coords[4] - this_zombie.rel_h_coords[1])
    local b = this_zombie.rel_h_coords[3] - m * this_zombie.rel_h_coords[1]
    local x
    
    if -b / m < draw_threshold
      or scale * this_zombie.rel_h_coords[3] / this_zombie.rel_h_coords[1] > love.graphics.getHeight() / 2
      or scale * this_zombie.rel_h_coords[6] / this_zombie.rel_h_coords[4] < -love.graphics.getHeight() / 2 then
      this_zombie.drawable = false
      return
    end
    
    -- Clip bottom if necessary
    if scale * this_zombie.rel_h_coords[3] / this_zombie.rel_h_coords[1] > -love.graphics.getHeight() / 2 then
      this_zombie.f_bottom = 0
    else
      x = b / (-n - m)
      this_zombie.f_bottom = (x - this_zombie.rel_h_coords[1]) / (this_zombie.rel_h_coords[4] - this_zombie.rel_h_coords[1])
    end
    
    -- Clip top if necessary
    if scale * this_zombie.rel_h_coords[6] / this_zombie.rel_h_coords[4] < love.graphics.getHeight() / 2 then
      this_zombie.f_top = 1
    else
      x = b / (n - m)
      this_zombie.f_top = (x - this_zombie.rel_h_coords[1]) / (this_zombie.rel_h_coords[4] - this_zombie.rel_h_coords[1])
    end
  end
  
  this_zombie.clip_h_coords = {}
  this_zombie.clip_h_coords[1] = this_zombie.rel_h_coords[1] + this_zombie.f_bottom * (this_zombie.rel_h_coords[4] - this_zombie.rel_h_coords[1])
  this_zombie.clip_h_coords[2] = this_zombie.rel_h_coords[2] + this_zombie.f_bottom * (this_zombie.rel_h_coords[5] - this_zombie.rel_h_coords[2])
  this_zombie.clip_h_coords[3] = this_zombie.rel_h_coords[3] + this_zombie.f_bottom * (this_zombie.rel_h_coords[6] - this_zombie.rel_h_coords[3])
  this_zombie.clip_h_coords[4] = this_zombie.rel_h_coords[1] + this_zombie.f_top * (this_zombie.rel_h_coords[4] - this_zombie.rel_h_coords[1])
  this_zombie.clip_h_coords[5] = this_zombie.rel_h_coords[2] + this_zombie.f_top * (this_zombie.rel_h_coords[5] - this_zombie.rel_h_coords[2])
  this_zombie.clip_h_coords[6] = this_zombie.rel_h_coords[3] + this_zombie.f_top * (this_zombie.rel_h_coords[6] - this_zombie.rel_h_coords[3])
end

function clip_poly_coordinates(rel_coords, clip_threshold)
  local vertices = #rel_coords / 3
  local clip_coords = {}
  prev = {}
  prev[1] = rel_coords[3*(vertices-1)+1]
  prev[2] = rel_coords[3*(vertices-1)+2]
  prev[3] = rel_coords[3*(vertices-1)+3]
  prev_drawable = prev[1] > clip_threshold
  k = 0
  for j = 0, vertices - 1, 1 do
    this_drawable = rel_coords[3*j+1] > clip_threshold
    if this_drawable == not prev_drawable then
      frac = (clip_threshold - prev[1]) / (rel_coords[3*j+1] - prev[1])
      clip_coords[3*k+1] = clip_threshold
      clip_coords[3*k+2] = prev[2] + frac * (rel_coords[3*j+2] - prev[2])
      clip_coords[3*k+3] = prev[3] + frac * (rel_coords[3*j+3] - prev[3])
      k = k + 1
    end
    if this_drawable then
      clip_coords[3*k+1] = rel_coords[3*j+1]
      clip_coords[3*k+2] = rel_coords[3*j+2]
      clip_coords[3*k+3] = rel_coords[3*j+3]
      k = k + 1
    end
    prev[1] = rel_coords[3*j+1]
    prev[2] = rel_coords[3*j+2]
    prev[3] = rel_coords[3*j+3]
    prev_drawable = prev[1] > clip_threshold
  end
  return clip_coords
end
